'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Close = require('./Close');

var _Close2 = _interopRequireDefault(_Close);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Alert = function (_React$Component) {
    _inherits(Alert, _React$Component);

    function Alert() {
        _classCallCheck(this, Alert);

        return _possibleConstructorReturn(this, (Alert.__proto__ || Object.getPrototypeOf(Alert)).apply(this, arguments));
    }

    _createClass(Alert, [{
        key: 'render',
        value: function render() {
            if (this.props.error === false && this.props.success === false) return null;
            var generateItems = function generateItems(item) {
                var items = [];
                item.forEach(function (item, key) {
                    return items.push(_react2.default.createElement(
                        'div',
                        { key: key },
                        item.text
                    ));
                });
                return items;
            };
            var msg = '';
            if (typeof this.props.data === 'string') {
                msg = this.props.data;
            } else if (_typeof(this.props.data) === 'object') {
                msg = generateItems(this.props.data);
            }

            return _react2.default.createElement(
                'div',
                { ref: this.props.errorRef, style: _extends({
                        padding: '25px',
                        position: 'relative',
                        backgroundColor: this.props.success ? 'green' : this.props.error ? 'red' : '#fff',
                        color: this.props.success || this.props.error ? '#fff' : '#000' }, this.props.style) },
                !this.props.hideClose ? _react2.default.createElement(_Close2.default, { style: { position: 'absolute', right: '15px', top: '15px' }, onClick: this.props.onClick, height: '15px', width: '15px', disableHover: true }) : null,
                msg
            );
        }
    }]);

    return Alert;
}(_react2.default.Component);

;

Alert.defaultProps = {
    onClick: function onClick() {},
    errorRef: function errorRef() {},
    hideClose: false,
    error: false,
    success: false,
    data: [],
    style: {}
};

Alert.propTypes = {
    onClick: _propTypes2.default.func,
    errorRef: _propTypes2.default.func,
    error: _propTypes2.default.bool,
    hideClose: _propTypes2.default.bool.require,
    data: _propTypes2.default.array,
    success: _propTypes2.default.bool,
    style: _propTypes2.default.object
};

module.exports = Alert;