'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Arrow = function (_React$Component) {
    _inherits(Arrow, _React$Component);

    function Arrow(props) {
        _classCallCheck(this, Arrow);

        var _this = _possibleConstructorReturn(this, (Arrow.__proto__ || Object.getPrototypeOf(Arrow)).call(this, props));

        _this.state = { hover: false };
        return _this;
    }

    _createClass(Arrow, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover && this.state.hover === nextState.hover && this.props.direction === nextProps.direction) {
                return false;
            }
            return true;
        }
    }, {
        key: 'hover',
        value: function hover() {
            this.setState({ hover: true });
        }
    }, {
        key: 'leave',
        value: function leave() {
            this.setState({ hover: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var degrees = this.props.direction === 'right' ? 180 : this.props.direction === 'top' ? 90 : this.props.direction === 'bottom' ? -90 : 0;

            return _react2.default.createElement(
                'div',
                { style: { height: this.props.height },
                    onMouseEnter: function onMouseEnter() {
                        return _this2.props.disableHover ? null : _this2.hover();
                    },
                    onMouseLeave: function onMouseLeave() {
                        return _this2.props.disableHover ? null : _this2.leave();
                    },
                    onClick: function onClick() {
                        return _this2.props.onClick();
                    }
                },
                this.props.text !== '' ? _react2.default.createElement(
                    'span',
                    { style: { color: this.state.hover ? this.props.colorHover : this.props.color } },
                    this.props.text
                ) : null,
                _react2.default.createElement(
                    'svg',
                    { viewBox: '0 0 451.8 451.8',
                        style: _extends({
                            cursor: 'pointer',
                            backgroundColor: this.state.hover ? this.props.backgroundHover : this.props.background,
                            width: this.props.width,
                            height: this.props.height,
                            transform: 'rotate(' + degrees + 'deg)'
                        }, this.props.style)
                    },
                    _react2.default.createElement('path', { d: 'M97.1 225.9c0-8.1 3.1-16.2 9.3-22.4L300.7 9.3c12.4-12.4 32.4-12.4 44.8 0 12.4 12.4 12.4 32.4 0 44.7L173.5 225.9l171.9 171.9c12.4 12.4 12.4 32.4 0 44.7 -12.4 12.4-32.4 12.4-44.7 0L106.4 248.3C100.2 242.1 97.1 234 97.1 225.9z',
                        fill: this.state.hover ? this.props.colorHover : this.props.color })
                )
            );
        }
    }]);

    return Arrow;
}(_react2.default.Component);

;

Arrow.defaultProps = {
    onClick: function onClick() {},
    color: 'black',
    text: '',
    colorHover: 'black',
    background: 'transparent',
    backgroundHover: 'transparent',
    width: '100%',
    height: 'auto',
    direction: 'left',
    style: {},
    disableHover: (0, _utils.isTouch)()
};

Arrow.propTypes = {
    onClick: _propTypes2.default.func,
    color: _propTypes2.default.string,
    colorHover: _propTypes2.default.string,
    background: _propTypes2.default.string,
    backgroundHover: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    direction: _propTypes2.default.string,
    text: _propTypes2.default.string,
    style: _propTypes2.default.object,
    disableHover: _propTypes2.default.bool
};

module.exports = Arrow;