'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_React$Component) {
    _inherits(Button, _React$Component);

    function Button(props) {
        _classCallCheck(this, Button);

        var _this = _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, props));

        _this.state = { hover: false };
        return _this;
    }

    _createClass(Button, [{
        key: 'hover',
        value: function hover() {
            this.setState({ hover: true });
        }
    }, {
        key: 'leave',
        value: function leave() {
            this.setState({ hover: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var icon = null;
            var stylesIcon = { marginRight: '10px' };
            var buttonDefaultStyles = {
                border: this.props.disabled ? 'none' : this.props.filled ? 'none' : '1px solid ' + (this.state.hover ? this.props.color : this.props.border),
                borderRadius: 25,
                padding: this.props.small ? '0 15px' : this.props.big ? '0 25px' : '0 20px',
                height: this.props.small ? '25px' : this.props.big ? '50px' : '35px',
                backgroundColor: this.props.disabled ? this.props.filled ? '#b5b5b5' : '#e3e3e3' : this.props.filled ? this.state.hover ? this.props.lighten ? (0, _color2.default)(this.props.color).lighten(0.1) : (0, _color2.default)(this.props.color).darken(0.1) : this.props.color : 'transparent',
                color: this.props.disabled ? this.props.filled ? '#e3e3e3' : '#b5b5b5' : this.props.filled ? '#fff' : this.props.color,
                cursor: this.props.disabled ? 'default' : 'pointer',
                fontSize: this.props.small ? '14px' : this.props.big ? '18px' : '16px',
                textTransform: 'uppercase',
                width: 'auto',
                outline: 'none',
                minWidth: this.props.small ? '100px' : this.props.big ? '130px' : '120px'
            };
            if (this.props.icon === 'plus') {
                icon = _react2.default.createElement(
                    'svg',
                    { style: stylesIcon, width: this.props.small ? '14px' : this.props.big ? '20px' : '16px', viewBox: '0 0 402 402' },
                    _react2.default.createElement('path', { d: 'M394 154.2c-5.3-5.3-11.8-8-19.4-8H255.8V27.4c0-7.6-2.7-14.1-8-19.4C242.5 2.7 236 0 228.4 0h-54.8c-7.6 0-14.1 2.7-19.4 8 -5.3 5.3-8 11.8-8 19.4v118.8H27.4c-7.6 0-14.1 2.7-19.4 8S0 166 0 173.6v54.8c0 7.6 2.7 14.1 8 19.4 5.3 5.3 11.8 8 19.4 8h118.8V374.6c0 7.6 2.7 14.1 8 19.4 5.3 5.3 11.8 8 19.4 8h54.8c7.6 0 14.1-2.7 19.4-8 5.3-5.3 8-11.8 8-19.4V255.8h118.8c7.6 0 14.1-2.7 19.4-8 5.3-5.3 8-11.8 8-19.4v-54.8C402 166 399.3 159.5 394 154.2z',
                        fill: this.props.disabled ? this.props.filled ? '#e3e3e3' : '#b5b5b5' : this.props.filled ? '#fff' : this.props.color
                    })
                );
            }
            if (this.props.icon === 'arrowRight') {
                icon = _react2.default.createElement(
                    'svg',
                    { style: stylesIcon, width: this.props.small ? '14px' : this.props.big ? '20px' : '16px', viewBox: '0 0 444.8 444.8' },
                    _react2.default.createElement('path', { d: 'M422 196.7L236.1 10.8C228.9 3.6 220.2 0 210.1 0c-9.9 0-18.5 3.6-25.7 10.8L163 32.3c-7.2 6.9-10.8 15.4-10.8 25.7 0 10.3 3.6 18.8 10.9 25.7l83.7 83.9H45.7c-9.9 0-17.9 3.6-24.1 10.7s-9.3 15.8-9.3 25.8v36.5c0 10.1 3.1 18.7 9.3 25.8s14.2 10.7 24.1 10.7h201L163 360.9c-7.2 7.2-10.8 15.9-10.8 26 0 10.1 3.6 18.8 10.9 26l21.4 21.4c7.4 7 16 10.6 25.7 10.6 9.9 0 18.6-3.5 26-10.6l185.9-185.9c7-7 10.6-15.7 10.6-26C432.5 211.9 429 203.4 422 196.7z',
                        fill: this.props.disabled ? this.props.filled ? '#e3e3e3' : '#b5b5b5' : this.props.filled ? '#fff' : this.props.color
                    })
                );
            }
            if (this.props.icon === 'share') {
                icon = _react2.default.createElement(
                    'svg',
                    { style: stylesIcon, width: this.props.small ? '14px' : this.props.big ? '20px' : '16px', viewBox: '0 0 511.6 511.6' },
                    _react2.default.createElement('path', { d: 'M506.2 179L360 32.8c-3.6-3.6-7.9-5.4-12.8-5.4s-9.2 1.8-12.8 5.4c-3.6 3.6-5.4 7.9-5.4 12.9v73.1h-64c-135.7 0-219 38.4-249.8 115.1C5 259.3 0 291 0 328.9c0 31.6 12.1 74.5 36.3 128.8 0.6 1.3 1.6 3.6 3 6.8 1.4 3.2 2.7 6.1 3.9 8.6 1.1 2.5 2.4 4.6 3.7 6.3 2.3 3.2 4.9 4.9 8 4.9 2.9 0 5.1-1 6.7-2.9 1.6-1.9 2.4-4.3 2.4-7.1 0-1.7-0.2-4.2-0.7-7.6 -0.5-3.3-0.7-5.6-0.7-6.7 -1-12.9-1.4-24.7-1.4-35.1 0-19.2 1.7-36.4 5-51.7 3.3-15.2 7.9-28.4 13.9-39.5 5.9-11.1 13.5-20.7 22.8-28.8 9.3-8.1 19.4-14.7 30.1-19.8 10.8-5.1 23.4-9.2 38-12.1 14.6-2.9 29.2-5 44-6.1s31.5-1.7 50.1-1.7h64v73.1c0 4.9 1.8 9.2 5.4 12.8 3.6 3.6 7.9 5.4 12.8 5.4 4.9 0 9.2-1.8 12.9-5.4l146.2-146.2c3.6-3.6 5.4-7.9 5.4-12.8C511.6 186.9 509.8 182.6 506.2 179z',
                        fill: this.props.disabled ? this.props.filled ? '#e3e3e3' : '#b5b5b5' : this.props.filled ? '#fff' : this.props.color
                    })
                );
            }

            return _react2.default.createElement(
                'button',
                {
                    type: this.props.type,
                    style: _extends({}, buttonDefaultStyles, this.props.style),
                    onClick: function onClick() {
                        return _this2.props.onClick();
                    },
                    onMouseEnter: function onMouseEnter() {
                        return _this2.hover();
                    },
                    onMouseLeave: function onMouseLeave() {
                        return _this2.leave();
                    },
                    disabled: this.props.disabled },
                icon,
                this.props.children
            );
        }
    }]);

    return Button;
}(_react2.default.Component);

;

Button.defaultProps = {
    children: 'Click Me',
    onClick: function onClick() {},
    filled: false,
    color: '#fff',
    border: '#b7b7b7',
    lighten: false,
    small: false,
    medium: false,
    big: false,
    disabled: false,
    type: 'button',
    icon: '',
    style: {}
};

Button.propTypes = {
    children: _propTypes2.default.string.isRequired,
    onClick: _propTypes2.default.func,
    filled: _propTypes2.default.bool,
    lighten: _propTypes2.default.bool,
    small: _propTypes2.default.bool,
    medium: _propTypes2.default.bool,
    big: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    color: _propTypes2.default.string,
    border: _propTypes2.default.string,
    style: _propTypes2.default.object,
    type: _propTypes2.default.string,
    icon: _propTypes2.default.string

};

module.exports = Button;