'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Check = function (_React$Component) {
    _inherits(Check, _React$Component);

    function Check(props) {
        _classCallCheck(this, Check);

        var _this = _possibleConstructorReturn(this, (Check.__proto__ || Object.getPrototypeOf(Check)).call(this, props));

        _this.state = { hover: false };
        return _this;
    }

    _createClass(Check, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover) {
                return false;
            }
            return true;
        }
    }, {
        key: 'hover',
        value: function hover() {
            this.setState({ hover: true });
        }
    }, {
        key: 'leave',
        value: function leave() {
            this.setState({ hover: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                'svg',
                { viewBox: '0 0 25 25',
                    style: _extends({
                        cursor: 'pointer',
                        width: this.props.width,
                        boxSizing: 'border-box',
                        height: this.props.height
                    }, this.props.style),
                    onMouseEnter: function onMouseEnter() {
                        return _this2.props.disableHover ? null : _this2.hover();
                    },
                    onMouseLeave: function onMouseLeave() {
                        return _this2.props.disableHover ? null : _this2.leave();
                    },
                    onClick: function onClick() {
                        return _this2.props.onClick();
                    }
                },
                _react2.default.createElement('circle', { cx: '12.5', cy: '12.5', r: '12.5', fill: this.state.hover ? this.props.backgroundHover : this.props.background }),
                _react2.default.createElement('path', { d: 'M19.4 9.3c0 0.2-0.1 0.4-0.2 0.6l-6.5 6.5 -1.2 1.2c-0.2 0.2-0.4 0.3-0.6 0.3 -0.2 0-0.4-0.1-0.6-0.2l-1.2-1.2 -3.2-3.2c-0.2-0.2-0.2-0.4-0.2-0.6 0-0.2 0.1-0.4 0.3-0.6l1.2-1.2c0.2-0.2 0.4-0.2 0.6-0.2 0.2 0 0.4 0.1 0.6 0.3l2.6 2.6 5.9-5.9c0.2-0.2 0.4-0.2 0.6-0.2s0.4 0.1 0.6 0.3l1.2 1.2C19.3 8.8 19.4 9 19.4 9.3z',
                    fill: this.state.hover ? this.props.colorHover : this.props.color })
            );
        }
    }]);

    return Check;
}(_react2.default.Component);

;

Check.defaultProps = {
    onClick: function onClick() {},
    color: '#fff',
    style: {},
    colorHover: '#fff',
    background: '#10AA00',
    backgroundHover: '#10AA00',
    width: '100%',
    height: '100%',
    disableHover: (0, _utils.isTouch)()
};

Check.propTypes = {
    onClick: _propTypes2.default.func,
    color: _propTypes2.default.string,
    colorHover: _propTypes2.default.string,
    background: _propTypes2.default.string,
    backgroundHover: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    style: _propTypes2.default.object,
    disableHover: _propTypes2.default.bool
};

module.exports = Check;