'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Close = function (_React$Component) {
    _inherits(Close, _React$Component);

    function Close(props) {
        _classCallCheck(this, Close);

        var _this = _possibleConstructorReturn(this, (Close.__proto__ || Object.getPrototypeOf(Close)).call(this, props));

        _this.state = { hover: false };
        return _this;
    }

    _createClass(Close, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover) {
                return false;
            }
            return true;
        }
    }, {
        key: 'hover',
        value: function hover() {
            this.setState({ hover: true });
        }
    }, {
        key: 'leave',
        value: function leave() {
            this.setState({ hover: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var viewBox = this.props.thin === true ? "0 0 122.5 122.5" : "0 0 48 48";
            var d = this.props.thin === true ? "M85.8 81c-6.6-6.6-13.1-13.1-19.7-19.7 12-12 24-24 36-36 6.5-6.5 13-13 19.5-19.5 3.1-3.1-1.7-7.9-4.8-4.8 -11.9 11.9-23.8 23.8-35.7 35.7C74.4 43.3 67.8 49.9 61.3 56.5c-12-12-24-24-36-36C18.8 14 12.3 7.5 5.8 1 2.7-2.1-2.1 2.7 1 5.8 12.9 17.8 24.9 29.7 36.8 41.6c6.6 6.6 13.1 13.1 19.7 19.7C44.5 73.3 32.5 85.3 20.5 97.2 14 103.7 7.5 110.2 1 116.7c-3.1 3.1 1.7 7.9 4.8 4.8 11.9-11.9 23.8-23.8 35.7-35.7 6.6-6.6 13.1-13.1 19.7-19.7 12 12 24 24 36 36 6.5 6.5 13 13 19.5 19.5 3.1 3.1 7.9-1.7 4.8-4.8C109.6 104.8 97.7 92.9 85.8 81z" : "M28.2 24L47.1 5.1c1.2-1.2 1.2-3.1 0-4.2 -1.2-1.2-3.1-1.2-4.2 0L24 19.7 5.1 0.9c-1.2-1.2-3.1-1.2-4.2 0 -1.2 1.2-1.2 3.1 0 4.2l18.9 18.9L0.9 42.9c-1.2 1.2-1.2 3.1 0 4.2C1.5 47.7 2.2 48 3 48s1.5-0.3 2.1-0.9l18.9-18.9L42.9 47.1c0.6 0.6 1.4 0.9 2.1 0.9s1.5-0.3 2.1-0.9c1.2-1.2 1.2-3.1 0-4.2L28.2 24z";
            return _react2.default.createElement(
                'svg',
                { viewBox: viewBox,
                    style: _extends({
                        cursor: 'pointer',
                        backgroundColor: this.state.hover ? this.props.backgroundHover : this.props.background,
                        width: this.props.width,
                        boxSizing: 'border-box',
                        height: this.props.height
                    }, this.props.style),
                    onMouseEnter: function onMouseEnter() {
                        return _this2.props.disableHover ? null : _this2.hover();
                    },
                    onMouseLeave: function onMouseLeave() {
                        return _this2.props.disableHover ? null : _this2.leave();
                    },
                    onClick: function onClick() {
                        return _this2.props.onClick();
                    }
                },
                _react2.default.createElement('path', { d: d,
                    fill: this.state.hover ? this.props.colorHover : this.props.color
                })
            );
        }
    }]);

    return Close;
}(_react2.default.Component);

;

Close.defaultProps = {
    onClick: function onClick() {},
    color: 'black',
    style: {},
    colorHover: 'red',
    background: 'transparent',
    backgroundHover: 'transparent',
    width: '100%',
    height: '100%',
    disableHover: (0, _utils.isTouch)(),
    thin: false
};

Close.propTypes = {
    onClick: _propTypes2.default.func,
    color: _propTypes2.default.string,
    colorHover: _propTypes2.default.string,
    background: _propTypes2.default.string,
    backgroundHover: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    style: _propTypes2.default.object,
    disableHover: _propTypes2.default.bool,
    thin: _propTypes2.default.bool
};

module.exports = Close;