'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Filter = function (_React$Component) {
    _inherits(Filter, _React$Component);

    function Filter(props) {
        _classCallCheck(this, Filter);

        var _this = _possibleConstructorReturn(this, (Filter.__proto__ || Object.getPrototypeOf(Filter)).call(this, props));

        _this.state = { hover: false };
        return _this;
    }

    _createClass(Filter, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover && this.props.color === nextProps.color && this.state.hover === nextState.hover) {
                return false;
            }
            return true;
        }
    }, {
        key: 'hover',
        value: function hover() {
            this.setState({ hover: true });
        }
    }, {
        key: 'leave',
        value: function leave() {
            this.setState({ hover: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                'svg',
                { viewBox: '0 0 402.6 402.6',
                    style: _extends({
                        cursor: 'pointer',
                        backgroundColor: this.state.hover ? this.props.backgroundHover : this.props.background,
                        width: this.props.width,
                        boxSizing: 'border-box',
                        height: this.props.height
                    }, this.props.style),
                    onMouseEnter: function onMouseEnter() {
                        return _this2.props.disableHover ? null : _this2.hover();
                    },
                    onMouseLeave: function onMouseLeave() {
                        return _this2.props.disableHover ? null : _this2.leave();
                    },
                    onClick: function onClick() {
                        return _this2.props.onClick();
                    }
                },
                _react2.default.createElement('path', { d: 'M400.9 11.4c-3.2-7.4-8.8-11.1-16.9-11.1H18.6c-8 0-13.6 3.7-16.8 11.1 -3.2 7.8-1.9 14.5 4 20l140.8 140.8v138.8c0 5 1.8 9.2 5.4 12.9l73.1 73.1c3.4 3.6 7.7 5.4 12.9 5.4 2.3 0 4.7-0.5 7.1-1.4 7.4-3.2 11.1-8.9 11.1-16.8V172.2L396.9 31.4C402.8 25.9 404.1 19.2 400.9 11.4z',
                    fill: this.state.hover ? this.props.colorHover : this.props.color })
            );
        }
    }]);

    return Filter;
}(_react2.default.Component);

;

Filter.defaultProps = {
    onClick: function onClick() {},
    color: 'black',
    style: {},
    colorHover: 'red',
    background: 'transparent',
    backgroundHover: 'transparent',
    width: '100%',
    height: '100%',
    disableHover: (0, _utils.isTouch)()
};

Filter.propTypes = {
    onClick: _propTypes2.default.func,
    color: _propTypes2.default.string,
    colorHover: _propTypes2.default.string,
    background: _propTypes2.default.string,
    backgroundHover: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    style: _propTypes2.default.object,
    disableHover: _propTypes2.default.bool
};

module.exports = Filter;