'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Home = function (_React$Component) {
    _inherits(Home, _React$Component);

    function Home(props) {
        _classCallCheck(this, Home);

        var _this = _possibleConstructorReturn(this, (Home.__proto__ || Object.getPrototypeOf(Home)).call(this, props));

        _this.state = { hover: false };
        return _this;
    }

    _createClass(Home, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover && this.props.color === nextProps.color && this.state.hover === nextState.hover) {
                return false;
            }
            return true;
        }
    }, {
        key: 'hover',
        value: function hover() {
            this.setState({ hover: true });
        }
    }, {
        key: 'leave',
        value: function leave() {
            this.setState({ hover: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                'div',
                { style: { position: 'relative', height: this.props.height, cursor: 'pointer' },
                    onMouseEnter: function onMouseEnter() {
                        return _this2.props.disableHover ? null : _this2.hover();
                    },
                    onMouseLeave: function onMouseLeave() {
                        return _this2.props.disableHover ? null : _this2.leave();
                    },
                    onClick: function onClick() {
                        return _this2.props.onClick();
                    }
                },
                _react2.default.createElement(
                    'svg',
                    { viewBox: '0 0 512 512',
                        style: _extends({
                            width: this.props.width,
                            height: this.props.height,
                            backgroundColor: this.state.hover || this.props.active ? this.props.backgroundHover : this.props.background }, this.props.style)

                    },
                    _react2.default.createElement('path', { d: 'M506.6 208.1L263.9 30.4c-4.7-3.4-11-3.4-15.7 0L5.4 208.1c-5.9 4.3-7.2 12.7-2.9 18.6s12.7 7.2 18.6 2.9L256 57.6l234.8 171.9c2.4 1.7 5.1 2.6 7.8 2.6 4.1 0 8.1-1.9 10.7-5.4C513.8 220.7 512.5 212.4 506.6 208.1z',
                        fill: this.state.hover || this.props.active ? this.props.colorHover : this.props.color }),
                    _react2.default.createElement('path', { d: 'M442.2 232.5c-7.3 0-13.3 6-13.3 13.3v211.7H322.5V342c0-36.7-29.8-66.5-66.5-66.5s-66.5 29.8-66.5 66.5v115.6H83.1V245.8c0-7.3-6-13.3-13.3-13.3s-13.3 6-13.3 13.3v225.1c0 7.3 6 13.3 13.3 13.3h133c7 0 12.7-5.4 13.3-12.3 0-0.3 0.1-0.7 0.1-1v-128.9c0-22 17.9-39.9 39.9-39.9s39.9 17.9 39.9 39.9v128.9c0 0.4 0 0.7 0.1 1 0.5 6.9 6.3 12.3 13.3 12.3h133c7.3 0 13.3-6 13.3-13.3V245.8C455.5 238.5 449.6 232.5 442.2 232.5z',
                        fill: this.state.hover || this.props.active ? this.props.colorHover : this.props.color })
                ),
                this.props.underline && (this.state.hover || this.props.active) ? _react2.default.createElement('span', { style: { width: '10px', height: '3px', position: 'absolute', bottom: '0', right: '0', left: '0', margin: '0 auto', background: this.props.colorHover } }) : null
            );
        }
    }]);

    return Home;
}(_react2.default.Component);

;

Home.defaultProps = {
    onClick: function onClick() {},
    color: 'black',
    colorHover: 'red',
    background: 'transparent',
    backgroundHover: 'transparent',
    width: '100%',
    height: '100%',
    underline: false,
    active: false,
    disableHover: (0, _utils.isTouch)(),
    style: {}
};

Home.propTypes = {
    onClick: _propTypes2.default.func,
    color: _propTypes2.default.string,
    colorHover: _propTypes2.default.string,
    background: _propTypes2.default.string,
    backgroundHover: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    underline: _propTypes2.default.bool,
    active: _propTypes2.default.bool,
    disableHover: _propTypes2.default.bool,
    style: _propTypes2.default.object

};

module.exports = Home;