'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_React$Component) {
    _inherits(Input, _React$Component);

    function Input(props) {
        _classCallCheck(this, Input);

        var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

        _this.handleChange = function (e) {
            var val = e.target.value;
            if (_this.props.debounce) {
                _this.setState({ value: val }, function () {
                    _this.changed(val);
                });
            } else {
                _this.props.onChange(val);
            }
        };

        _this.state = { focus: false, value: props.value };
        _this.changed = (0, _lodash2.default)(_this.props.onChange, 250);
        return _this;
    }

    _createClass(Input, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover && this.props.color === nextProps.color && this.state.value === nextState.value && this.props.value === nextProps.value && this.state.focus === nextState.focus) {
                return false;
            }
            return true;
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps, nextState) {
            if (this.props.debounce === true) {
                if (nextProps.value == '') {
                    this.setState({ value: nextProps.value });
                }
            }
        }
    }, {
        key: 'focus',
        value: function focus() {
            this.setState({ focus: true });
        }
    }, {
        key: 'blur',
        value: function blur() {
            this.setState({ focus: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var defaultStyles = {
                border: '1px solid',
                borderColor: this.state.focus ? this.props.borderActive : this.props.border,
                fontSize: 'inherit',
                color: 'inherit',
                fontFamily: 'inherit',
                borderRadius: 5,
                padding: '8px 12px',
                width: this.props.width,
                backgroundColor: 'transparent',
                height: this.props.height,
                outlineStyle: 'none',
                boxSizing: 'border-box',
                appearance: 'none',
                WebkitAppearance: 'none'
            };

            return this.props.type === 'text' ? _react2.default.createElement('input', {
                onFocus: function onFocus() {
                    return _this2.focus();
                },
                onBlur: function onBlur() {
                    return _this2.blur();
                },
                onChange: this.handleChange,
                style: _extends({}, defaultStyles, this.props.style),
                type: 'text',
                maxLength: this.props.max,
                value: this.props.debounce ? this.state.value : this.props.value,
                placeholder: this.props.placeholder
            }) : this.props.type === 'number' ? _react2.default.createElement('input', {
                onFocus: function onFocus() {
                    return _this2.focus();
                },
                onBlur: function onBlur() {
                    return _this2.blur();
                },
                onChange: function onChange(e) {
                    return _this2.props.onChange(e.target.value);
                },
                style: _extends({}, defaultStyles, this.props.style),
                type: 'number',
                min: this.props.min,
                max: this.props.max,
                value: this.props.value
            }) : this.props.type === 'select' ? _react2.default.createElement(
                'div',
                { style: { position: 'relative', zIndex: '1', width: '100%' } },
                _react2.default.createElement(
                    'select',
                    {
                        onFocus: function onFocus() {
                            return _this2.focus();
                        },
                        onBlur: function onBlur() {
                            return _this2.blur();
                        },
                        onChange: function onChange(e) {
                            return _this2.props.onChange(e.target.value);
                        },
                        style: _extends({}, defaultStyles, this.props.style),
                        value: this.props.value },
                    this.props.options.map(function (option) {
                        return _react2.default.createElement(
                            'option',
                            { key: option['id'], value: option['id'] },
                            option['name']
                        );
                    })
                ),
                _react2.default.createElement(
                    'svg',
                    { style: {
                            position: 'absolute',
                            top: '7px',
                            right: '5px',
                            zIndex: '-1'
                        },
                        fill: '#acacac',
                        height: '24',
                        viewBox: '0 0 24 24',
                        width: '24' },
                    _react2.default.createElement('path', { d: 'M7 10l5 5 5-5z',
                        fill: this.state.focus ? this.props.borderActive : this.props.border }),
                    _react2.default.createElement('path', { d: 'M0 0h24v24H0z', fill: 'none' })
                )
            ) : _react2.default.createElement('input', {
                onFocus: function onFocus() {
                    return _this2.focus();
                },
                onBlur: function onBlur() {
                    return _this2.blur();
                },
                onChange: this.handleChange,
                style: _extends({}, defaultStyles, this.props.style),
                type: this.props.type,
                maxLength: this.props.max,
                value: this.props.debounce ? this.state.value : this.props.value,
                placeholder: this.props.placeholder
            });
        }
    }]);

    return Input;
}(_react2.default.Component);

;

Input.defaultProps = {
    onChange: function onChange() {},
    border: '#acacac',
    debounce: false,
    placeholder: '',
    borderActive: '#acacac',
    height: '40px',
    type: 'text',
    width: '100%',
    value: '',
    min: '0',
    max: '9999',
    style: {},
    options: []
};

Input.propTypes = {
    onChange: _propTypes2.default.func,
    border: _propTypes2.default.string,
    borderActive: _propTypes2.default.string,
    debounce: _propTypes2.default.bool,
    height: _propTypes2.default.string,
    type: _propTypes2.default.string,
    width: _propTypes2.default.string,
    value: _propTypes2.default.string,
    placeholder: _propTypes2.default.string,
    min: _propTypes2.default.string,
    max: _propTypes2.default.string,
    style: _propTypes2.default.object,
    options: _propTypes2.default.array

};

module.exports = Input;