'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Question = function (_React$Component) {
    _inherits(Question, _React$Component);

    function Question(props) {
        _classCallCheck(this, Question);

        var _this = _possibleConstructorReturn(this, (Question.__proto__ || Object.getPrototypeOf(Question)).call(this, props));

        _this.state = { hover: false };
        return _this;
    }

    _createClass(Question, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover && this.props.color === nextProps.color && this.state.hover === nextState.hover) {
                return false;
            }
            return true;
        }
    }, {
        key: 'hover',
        value: function hover() {
            this.setState({ hover: true });
        }
    }, {
        key: 'leave',
        value: function leave() {
            this.setState({ hover: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                'div',
                {
                    onMouseEnter: function onMouseEnter() {
                        return _this2.props.disableHover ? null : _this2.hover();
                    },
                    onMouseLeave: function onMouseLeave() {
                        return _this2.props.disableHover ? null : _this2.leave();
                    },
                    onClick: function onClick() {
                        return _this2.props.onClick();
                    },
                    style: _extends({ display: 'flex', alignItems: 'center', cursor: 'pointer', color: this.state.hover ? this.props.colorHover : this.props.color }, this.props.style) },
                _react2.default.createElement(
                    'svg',
                    { viewBox: '-418 -29.8 226.8 226.8',
                        style: {
                            marginRight: '10px',
                            width: this.props.width,
                            height: this.props.height
                        }
                    },
                    _react2.default.createElement('path', { d: 'M-306.1-29.8c-62.6 0.8-112.7 52.3-111.9 114.9 0.8 62.6 52.3 112.7 114.9 111.9 62.6-0.8 112.7-52.3 111.9-114.9C-192.1 19.5-243.5-30.6-306.1-29.8zM-306.5 152.6l-0.6 0c-9.6-0.3-16.4-7.4-16.2-16.9 0.3-9.3 7.2-16.1 16.6-16.1l0.6 0c9.9 0.3 16.6 7.3 16.4 17.1C-290.1 146.1-296.9 152.6-306.5 152.6zM-265.9 72.1c-2.3 3.2-7.3 7.2-13.5 12.1l-6.9 4.8c-3.8 3-6.1 5.7-6.9 8.5 -0.7 2.2-1 2.7-1.1 7.1l0 1.1h-26.4l0.1-2.2c0.3-9.2 0.5-14.6 4.4-19.1 6-7 19.2-15.5 19.7-15.9 1.9-1.4 3.5-3 4.7-4.8 2.8-3.8 4-6.8 4-9.8 0-4.1-1.2-7.9-3.6-11.3 -2.3-3.3-6.7-4.9-13.1-4.9 -6.3 0-10.6 2-13.2 6.1 -2.7 4.2-4 8.7-4 13.2v1.1h-27.2l0-1.2c0.7-16.7 6.7-28.7 17.7-35.7 6.9-4.5 15.6-6.7 25.6-6.7 13.2 0 24.3 3.2 33.1 9.5 8.9 6.4 13.4 16 13.4 28.5C-259.3 59.6-261.5 66.1-265.9 72.1z',
                        fill: this.state.hover ? this.props.colorHover : this.props.color })
                ),
                this.props.children
            );
        }
    }]);

    return Question;
}(_react2.default.Component);

;

Question.defaultProps = {
    onClick: function onClick() {},
    children: '',
    color: 'black',
    colorHover: 'red',
    width: '100%',
    height: '100%',
    style: {},
    disableHover: (0, _utils.isTouch)()
};

Question.propTypes = {
    onClick: _propTypes2.default.func,
    color: _propTypes2.default.string,
    colorHover: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    children: _propTypes2.default.string,
    style: _propTypes2.default.object,
    disableHover: _propTypes2.default.bool
};

module.exports = Question;