'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Text = function (_React$Component) {
    _inherits(Text, _React$Component);

    function Text(props) {
        _classCallCheck(this, Text);

        var _this = _possibleConstructorReturn(this, (Text.__proto__ || Object.getPrototypeOf(Text)).call(this, props));

        _this.state = { hover: false };
        return _this;
    }

    _createClass(Text, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover && this.props.color === nextProps.color && this.state.hover === nextState.hover) {
                return false;
            }
            return true;
        }
    }, {
        key: 'hover',
        value: function hover() {
            this.setState({ hover: true });
        }
    }, {
        key: 'leave',
        value: function leave() {
            this.setState({ hover: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                'div',
                {
                    onClick: function onClick() {
                        return _this2.props.onClick();
                    },
                    onMouseEnter: function onMouseEnter() {
                        return _this2.props.disableHover ? null : _this2.hover();
                    },
                    onMouseLeave: function onMouseLeave() {
                        return _this2.props.disableHover ? null : _this2.leave();
                    },
                    style: _extends({ display: 'flex', alignItems: 'center', justifyContent: 'center', cursor: 'pointer', position: 'relative', color: this.state.hover || this.props.active ? this.props.colorHover : this.props.color }, this.props.style) },
                this.props.children,
                this.props.underline && (this.state.hover || this.props.active) ? _react2.default.createElement('span', { style: { width: this.props.underlineFull ? '100%' : '10px', height: '3px', position: 'absolute', bottom: '0', right: '0', left: '0', margin: '0 auto', background: this.props.colorHover } }) : null
            );
        }
    }]);

    return Text;
}(_react2.default.Component);

;

Text.defaultProps = {
    onClick: function onClick() {},
    color: 'inherit',
    colorHover: 'inherit',
    children: 'Click me',
    underline: false,
    active: false,
    underlineFull: false,
    style: {},
    disableHover: (0, _utils.isTouch)()
};

Text.propTypes = {
    onClick: _propTypes2.default.func,
    color: _propTypes2.default.string,
    colorHover: _propTypes2.default.string,
    children: _propTypes2.default.string,
    underline: _propTypes2.default.bool,
    active: _propTypes2.default.bool,
    disableHover: _propTypes2.default.bool,
    underlineFull: _propTypes2.default.bool,
    style: _propTypes2.default.object
};

module.exports = Text;