'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _filter = require('./filter.css');

var _filter2 = _interopRequireDefault(_filter);

var _index = require('../../../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var filter = function filter(_ref) {
    var color = _ref.color,
        changeActivePosition = _ref.changeActivePosition,
        activePosition = _ref.activePosition,
        changeActiveClub = _ref.changeActiveClub,
        activeClub = _ref.activeClub,
        changeActiveStats = _ref.changeActiveStats,
        activeStats = _ref.activeStats,
        activeSearchTab = _ref.activeSearchTab,
        toogleActiveFilter = _ref.toogleActiveFilter,
        textSearchVal = _ref.textSearchVal,
        changeTextSearchVal = _ref.changeTextSearchVal;


    var content = null;
    if (!activeSearchTab) {
        content = _react2.default.createElement(
            'div',
            { className: _filter2.default.filterContent },
            _react2.default.createElement(_index.Input, {
                type: 'select',
                borderActive: color,
                border: '#acacac',
                options: [{ id: 0, name: 'Choose position' }, { id: 1, name: 'GK' }, { id: 2, name: 'DF' }, { id: 3, name: 'FW' }, { id: 4, name: 'MF' }],
                onChange: changeActivePosition,
                value: activePosition
            }),
            _react2.default.createElement(_index.Input, {
                style: { marginLeft: '25px' },
                type: 'select',
                borderActive: color,
                border: '#acacac',
                options: [{ id: 0, name: 'Choose club' }, { id: 1, name: 'Arsenal' }, { id: 2, name: 'West Ham' }],
                onChange: changeActiveClub,
                value: activeClub
            }),
            _react2.default.createElement(
                'div',
                { className: _filter2.default.filterWithText },
                _react2.default.createElement(
                    'div',
                    { className: _filter2.default.textBeforeselect },
                    'Show'
                ),
                _react2.default.createElement(_index.Input, {
                    type: 'select',
                    borderActive: color,
                    border: '#acacac',
                    options: [{ id: 'goals', name: 'Goals' }, { id: 'assists', name: 'Assists' }, { id: 'pop', name: 'Popularity' }],
                    onChange: changeActiveStats,
                    value: activeStats
                })
            )
        );
    } else if (activeSearchTab) {
        content = _react2.default.createElement(
            'div',
            { className: _filter2.default.filterContent },
            _react2.default.createElement(
                'div',
                { className: _filter2.default.textSearchBlock },
                _react2.default.createElement(_index.Search, { style: { position: 'absolute', top: '0px', left: '15px' }, color: '#999', colorHover: '#999', width: '20px' }),
                _react2.default.createElement(_index.Input, {
                    width: '100%',
                    style: { paddingLeft: '45px' },
                    type: 'text',
                    borderActive: color,
                    border: '#acacac',
                    onChange: changeTextSearchVal,
                    value: textSearchVal

                }),
                _react2.default.createElement(
                    'div',
                    { className: _filter2.default.clear },
                    _react2.default.createElement(_index.Close, {
                        style: { padding: '5px', borderRadius: '30px' },
                        width: '30px',
                        background: '#999',
                        color: '#fff',
                        colorHover: color,
                        onClick: function onClick() {
                            return changeTextSearchVal('');
                        }
                    })
                )
            )
        );
    }
    return _react2.default.createElement(
        'div',
        { className: _filter2.default.filterBlock },
        _react2.default.createElement(
            'div',
            { className: _filter2.default.choose },
            _react2.default.createElement(
                'div',
                { className: _filter2.default.filter },
                _react2.default.createElement(_index.Filter, { onClick: function onClick() {
                        return toogleActiveFilter(false);
                    }, style: { padding: '13px' }, color: !activeSearchTab ? color : '#999', colorHover: color, background: !activeSearchTab ? '#f7f7f7' : '#fff', backgroundHover: '#f7f7f7' })
            ),
            _react2.default.createElement(
                'div',
                { className: _filter2.default.search },
                _react2.default.createElement(_index.Search, { onClick: function onClick() {
                        return toogleActiveFilter(true);
                    }, style: { padding: '13px' }, color: activeSearchTab ? color : '#999', colorHover: color, background: activeSearchTab ? '#f7f7f7' : '#fff', backgroundHover: '#f7f7f7' })
            )
        ),
        content
    );
};

module.exports = filter;