'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UserShape = function (_React$Component) {
    _inherits(UserShape, _React$Component);

    function UserShape(props) {
        _classCallCheck(this, UserShape);

        var _this = _possibleConstructorReturn(this, (UserShape.__proto__ || Object.getPrototypeOf(UserShape)).call(this, props));

        _this.state = { hover: false };
        return _this;
    }

    _createClass(UserShape, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.props.color === this.props.colorHover && this.props.color === nextProps.color && this.state.hover === nextState.hover) {
                return false;
            }
            return true;
        }
    }, {
        key: 'hover',
        value: function hover() {
            this.setState({ hover: true });
        }
    }, {
        key: 'leave',
        value: function leave() {
            this.setState({ hover: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var lockStyle = _extends({
                cursor: this.props.pointer ? 'pointer' : 'default',
                width: this.props.width,
                boxSizing: 'border-box',
                height: this.props.height
            }, this.props.style);

            if (this.props.unlockHalf === true) {
                return _react2.default.createElement(
                    'svg',
                    { viewBox: '0 0 438.5 438.5',
                        style: lockStyle,
                        onMouseEnter: function onMouseEnter() {
                            return _this2.props.disableHover ? null : _this2.hover();
                        },
                        onMouseLeave: function onMouseLeave() {
                            return _this2.props.disableHover ? null : _this2.leave();
                        },
                        onClick: function onClick() {
                            return _this2.props.onClick();
                        }
                    },
                    _react2.default.createElement('path', { d: 'M375.7 227.3c-5.3-5.3-11.8-8-19.4-8H146.2v-91.4c0-20.2 7.1-37.4 21.4-51.7 14.3-14.3 31.5-21.4 51.7-21.4 20.2 0 37.4 7.1 51.7 21.4 14.3 14.3 21.4 31.5 21.4 51.7 0 4.9 1.8 9.2 5.4 12.8 3.6 3.6 7.9 5.4 12.8 5.4h18.3c4.9 0 9.2-1.8 12.8-5.4 3.6-3.6 5.4-7.9 5.4-12.8 0-35.2-12.5-65.3-37.5-90.4C284.6 12.5 254.5 0 219.3 0c-35.2 0-65.3 12.5-90.4 37.5 -25 25-37.5 55.1-37.5 90.4v91.4h-9.1c-7.6 0-14.1 2.7-19.4 8 -5.3 5.3-8 11.8-8 19.4v164.5c0 7.6 2.7 14.1 8 19.4 5.3 5.3 11.8 8 19.4 8h274.1c7.6 0 14.1-2.7 19.4-8 5.3-5.3 8-11.8 8-19.4V246.7C383.7 239.1 381.1 232.6 375.7 227.3z',
                        fill: this.state.hover ? this.props.colorHover : this.props.color })
                );
            }
            if (this.props.unlock === true) {
                return _react2.default.createElement(
                    'svg',
                    { viewBox: '0 0 475.1 475.1',
                        style: lockStyle,
                        onMouseEnter: function onMouseEnter() {
                            return _this2.props.disableHover ? null : _this2.hover();
                        },
                        onMouseLeave: function onMouseLeave() {
                            return _this2.props.disableHover ? null : _this2.leave();
                        },
                        onClick: function onClick() {
                            return _this2.props.onClick();
                        }
                    },
                    _react2.default.createElement('path', { d: 'M437.5 74.1c-25-25-55.2-37.5-90.4-37.5 -35.2 0-65.3 12.5-90.4 37.5 -25 25-37.5 55.2-37.5 90.4v54.8H27.4c-7.6 0-14.1 2.7-19.4 8C2.7 232.6 0 239.1 0 246.7v164.5c0 7.6 2.7 14.1 8 19.4 5.3 5.3 11.8 8 19.4 8h274.1c7.6 0 14.1-2.7 19.4-8 5.3-5.3 8-11.8 8-19.4V246.7c0-7.6-2.7-14.1-8-19.4 -5.3-5.3-11.8-8-19.4-8h-27.4v-54.8c0-20.2 7.1-37.4 21.4-51.7 14.3-14.3 31.5-21.4 51.7-21.4 20.2 0 37.4 7.1 51.7 21.4 14.3 14.3 21.4 31.5 21.4 51.7v73.1c0 5 1.8 9.2 5.4 12.8 3.6 3.6 7.9 5.4 12.8 5.4h18.3c4.9 0 9.2-1.8 12.8-5.4 3.6-3.6 5.4-7.9 5.4-12.8v-73.1C475.1 129.2 462.6 99.1 437.5 74.1z',
                        fill: this.state.hover ? this.props.colorHover : this.props.color })
                );
            }
            return _react2.default.createElement(
                'svg',
                { viewBox: '0 0 402 402',
                    style: lockStyle,
                    onMouseEnter: function onMouseEnter() {
                        return _this2.props.disableHover ? null : _this2.hover();
                    },
                    onMouseLeave: function onMouseLeave() {
                        return _this2.props.disableHover ? null : _this2.leave();
                    },
                    onClick: function onClick() {
                        return _this2.props.onClick();
                    }
                },
                _react2.default.createElement('path', { d: 'M357.5 190.7c-5.3-5.3-11.8-8-19.4-8h-9.1v-54.8c0-35-12.6-65.1-37.7-90.2C266.1 12.6 236 0 201 0c-35 0-65.1 12.6-90.2 37.7C85.7 62.8 73.1 92.9 73.1 127.9v54.8h-9.1c-7.6 0-14.1 2.7-19.4 8 -5.3 5.3-8 11.8-8 19.4V374.6c0 7.6 2.7 14.1 8 19.4 5.3 5.3 11.8 8 19.4 8H338c7.6 0 14.1-2.7 19.4-8 5.3-5.3 8-11.8 8-19.4V210.1C365.5 202.5 362.8 196.1 357.5 190.7zM274.1 182.7H127.9v-54.8c0-20.2 7.1-37.4 21.4-51.7 14.3-14.3 31.5-21.4 51.7-21.4 20.2 0 37.4 7.1 51.7 21.4 14.3 14.3 21.4 31.5 21.4 51.7V182.7z',
                    fill: this.state.hover ? this.props.colorHover : this.props.color })
            );
        }
    }]);

    return UserShape;
}(_react2.default.Component);

;

UserShape.defaultProps = {
    onClick: function onClick() {},
    color: 'black',
    style: {},
    colorHover: 'black',
    width: '100%',
    height: '100%',
    disableHover: (0, _utils.isTouch)(),
    unlock: false,
    unlockHalf: false,
    pointer: false

};

UserShape.propTypes = {
    onClick: _propTypes2.default.func,
    color: _propTypes2.default.string,
    colorHover: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    style: _propTypes2.default.object,
    disableHover: _propTypes2.default.bool,
    unlock: _propTypes2.default.bool,
    unlockHalf: _propTypes2.default.bool,
    pointer: _propTypes2.default.bool
};

module.exports = UserShape;