'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _holder;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Close = require('./Close');

var _Close2 = _interopRequireDefault(_Close);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var holder = (_holder = { width: '100%',
    height: '100%',
    position: 'fixed',
    top: '0',
    left: '0',
    transform: 'translateZ(0)'
}, _defineProperty(_holder, 'transform', 'translate3d(0, 0, 0)'), _defineProperty(_holder, 'zIndex', '999'), _holder);
var overlay = {
    width: '100%',
    height: '100%',
    position: 'relative',
    overflowY: 'auto',
    zIndex: '1',
    background: 'rgba(0,0,0,0.5)'
};

var close = {
    position: 'absolute',
    top: '15px',
    right: '15px'
};

var shadow = {
    width: '100%',
    height: '100%',
    position: 'absolute',
    top: '0',
    left: '0',
    zIndex: '0'
};

var Modal = function (_React$Component) {
    _inherits(Modal, _React$Component);

    function Modal() {
        _classCallCheck(this, Modal);

        return _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).apply(this, arguments));
    }

    _createClass(Modal, [{
        key: 'render',
        value: function render() {
            var _content,
                _this2 = this;

            var content = (_content = {
                zIndex: '1',
                backgroundColor: '#fcfcfc',
                position: 'relative',
                boxShadow: this.props.shadow === true ? '0 0 20px #333' : 'none',
                margin: 'auto',
                overflow: 'hidden',
                //right: '0',
                top: '50%',
                left: '50%',
                transform: 'translate(-50%, -50%)'
            }, _defineProperty(_content, 'position', 'fixed'), _defineProperty(_content, 'minHeight', '300px'), _defineProperty(_content, 'borderRadius', this.props.roundCorners === true ? '5px' : '0px'), _defineProperty(_content, 'width', '100%'), _defineProperty(_content, 'maxWidth', this.props.maxWidth), _content);
            var contentStyle = _extends({}, content, this.props.contentStyle);
            return _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                    'div',
                    { style: holder },
                    _react2.default.createElement('div', { style: overlay, onClick: function onClick() {
                            return _this2.props.remove();
                        } }),
                    _react2.default.createElement(
                        'div',
                        { style: contentStyle },
                        this.props.close ? _react2.default.createElement(
                            'div',
                            { style: close },
                            _react2.default.createElement(_Close2.default, { thin: this.props.closeThin, width: this.props.closeWidth, height: this.props.closeWidth, disableHover: true, onClick: function onClick() {
                                    return _this2.props.remove();
                                }, color: this.props.closeColor })
                        ) : null,
                        this.props.children
                    )
                ),
                _react2.default.createElement('div', { style: shadow })
            );
        }
    }]);

    return Modal;
}(_react2.default.Component);

Modal.defaultProps = {
    children: {},
    remove: function remove() {},
    close: true,
    closeColor: '#a5a5a5',
    closeWidth: '20px',
    maxWidth: '500px',
    closeThin: false,
    roundCorners: false,
    shadow: false,
    contentStyle: {}

};

Modal.propTypes = {
    children: _propTypes2.default.object.isRequired,
    remove: _propTypes2.default.func,
    close: _propTypes2.default.bool,
    closeThin: _propTypes2.default.bool,
    shadow: _propTypes2.default.bool,
    borderRadius: _propTypes2.default.bool,
    roundCorners: _propTypes2.default.bool,
    closeColor: _propTypes2.default.string,
    closeWidth: _propTypes2.default.string,
    maxWidth: _propTypes2.default.string,
    contentStyle: _propTypes2.default.object
};

module.exports = Modal;