'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UserShape = function (_React$Component) {
    _inherits(UserShape, _React$Component);

    function UserShape(props) {
        _classCallCheck(this, UserShape);

        var _this = _possibleConstructorReturn(this, (UserShape.__proto__ || Object.getPrototypeOf(UserShape)).call(this, props));

        _this.state = { hover: false };
        return _this;
    }

    _createClass(UserShape, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (this.props.color === this.props.colorHover && this.props.color === nextProps.color && this.state.hover === nextState.hover) {
                return false;
            }
            return true;
        }
    }, {
        key: 'hover',
        value: function hover() {
            this.setState({ hover: true });
        }
    }, {
        key: 'leave',
        value: function leave() {
            this.setState({ hover: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                'svg',
                { viewBox: '0 0 438.5 438.5',
                    style: _extends({
                        cursor: this.props.pointer ? 'pointer' : 'default',
                        width: this.props.width,
                        boxSizing: 'border-box',
                        height: this.props.height
                    }, this.props.style),
                    onMouseEnter: function onMouseEnter() {
                        return _this2.props.disableHover ? null : _this2.hover();
                    },
                    onMouseLeave: function onMouseLeave() {
                        return _this2.props.disableHover ? null : _this2.leave();
                    },
                    onClick: function onClick() {
                        return _this2.props.onClick();
                    }
                },
                _react2.default.createElement('path', { d: 'M219.3 219.3c30.3 0 56.1-10.7 77.5-32.1 21.4-21.4 32.1-47.2 32.1-77.5 0-30.3-10.7-56.1-32.1-77.5C275.4 10.7 249.5 0 219.3 0S163.2 10.7 141.8 32.1c-21.4 21.4-32.1 47.3-32.1 77.5 0 30.3 10.7 56.1 32.1 77.5C163.2 208.6 189 219.3 219.3 219.3z',
                    fill: this.state.hover ? this.props.colorHover : this.props.color }),
                _react2.default.createElement('path', { d: 'M419.3 335c-0.7-9.6-2-20-4-31.1 -2-11.1-4.5-21.5-7.6-31 -3-9.5-7.1-18.8-12.3-27.8 -5.1-9-11-16.7-17.7-23.1 -6.7-6.4-14.8-11.5-24.4-15.3 -9.6-3.8-20.2-5.7-31.8-5.7 -1.7 0-5.7 2-12 6.1 -6.3 4.1-13.4 8.7-21.3 13.7 -7.9 5-18.2 9.6-30.8 13.7 -12.7 4.1-25.4 6.1-38.1 6.1 -12.8 0-25.5-2-38.1-6.1 -12.7-4.1-22.9-8.7-30.8-13.7 -7.9-5-15-9.6-21.3-13.7 -6.3-4.1-10.3-6.1-12-6.1 -11.6 0-22.2 1.9-31.8 5.7 -9.6 3.8-17.7 8.9-24.4 15.3 -6.7 6.4-12.6 14.1-17.7 23.1 -5.1 9-9.2 18.3-12.3 27.8 -3 9.5-5.6 19.8-7.6 31 -2 11.1-3.3 21.5-4 31.1 -0.7 9.6-1 19.5-1 29.6 0 22.8 6.9 40.9 20.8 54.1 13.9 13.2 32.4 19.8 55.4 19.8h249.5c23 0 41.5-6.6 55.4-19.8 13.9-13.2 20.8-31.3 20.8-54.1C420.3 354.5 419.9 344.7 419.3 335z',
                    fill: this.state.hover ? this.props.colorHover : this.props.color }),
                '/>'
            );
        }
    }]);

    return UserShape;
}(_react2.default.Component);

;

UserShape.defaultProps = {
    onClick: function onClick() {},
    color: 'black',
    style: {},
    colorHover: 'black',
    width: '100%',
    height: '100%',
    disableHover: (0, _utils.isTouch)(),
    pointer: false

};

UserShape.propTypes = {
    onClick: _propTypes2.default.func,
    color: _propTypes2.default.string,
    colorHover: _propTypes2.default.string,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    style: _propTypes2.default.object,
    disableHover: _propTypes2.default.bool,
    pointer: _propTypes2.default.bool
};

module.exports = UserShape;