import React from 'react';
import PropTypes from 'prop-types';
import Color from 'color';

class Button extends React.Component {
    constructor(props) {
        super(props);
        this.state = {hover: false};
    }
    hover() {
        this.setState({hover: true});
    }
    leave() {
        this.setState({hover: false});
    }

    render () {
        let icon = null;
        const stylesIcon = {marginRight: '10px'};
        const buttonDefaultStyles = {
            border:  this.props.disabled ? 'none' : this.props.filled ? 'none' : '1px solid ' + (this.state.hover ? this.props.color : this.props.border),
            borderRadius: 25,
            padding: this.props.small ? '0 15px' : this.props.big ? '0 25px' : '0 20px',
            height: this.props.small ? '25px' : this.props.big ? '50px' : '35px',
            backgroundColor:
            this.props.disabled ?
                this.props.filled ?
                    '#b5b5b5'
                    :
                    '#e3e3e3'
                :
                this.props.filled ?
                    this.state.hover ?
                        this.props.lighten ?
                            Color(this.props.color).lighten(0.1) :
                            Color(this.props.color).darken(0.1) :
                        this.props.color : 'transparent',
            color: this.props.disabled ?
                this.props.filled ?
                    '#e3e3e3'
                    :
                    '#b5b5b5'
                :
                this.props.filled ? '#fff' : this.props.color,
            cursor: this.props.disabled ?
                'default'
                :
                'pointer',
            fontSize: this.props.small ? '14px' : this.props.big ? '18px' : '16px',
            textTransform: 'uppercase',
            width: 'auto',
            outline: 'none',
            minWidth: this.props.small ? '100px' : this.props.big ? '130px' : '120px',
        };
        if (this.props.icon === 'plus') {
            icon = <svg style={stylesIcon} width={this.props.small ? '14px' : this.props.big ? '20px' : '16px'} viewBox="0 0 402 402">
                <path d="M394 154.2c-5.3-5.3-11.8-8-19.4-8H255.8V27.4c0-7.6-2.7-14.1-8-19.4C242.5 2.7 236 0 228.4 0h-54.8c-7.6 0-14.1 2.7-19.4 8 -5.3 5.3-8 11.8-8 19.4v118.8H27.4c-7.6 0-14.1 2.7-19.4 8S0 166 0 173.6v54.8c0 7.6 2.7 14.1 8 19.4 5.3 5.3 11.8 8 19.4 8h118.8V374.6c0 7.6 2.7 14.1 8 19.4 5.3 5.3 11.8 8 19.4 8h54.8c7.6 0 14.1-2.7 19.4-8 5.3-5.3 8-11.8 8-19.4V255.8h118.8c7.6 0 14.1-2.7 19.4-8 5.3-5.3 8-11.8 8-19.4v-54.8C402 166 399.3 159.5 394 154.2z"
                      fill={this.props.disabled ?
                          this.props.filled ?
                              '#e3e3e3'
                              :
                              '#b5b5b5'
                          :
                          this.props.filled ? '#fff' : this.props.color}
                /></svg>
        }
        if (this.props.icon === 'arrowRight') {
            icon = <svg style={stylesIcon} width={this.props.small ? '14px' : this.props.big ? '20px' : '16px'} viewBox="0 0 444.8 444.8">
                <path d="M422 196.7L236.1 10.8C228.9 3.6 220.2 0 210.1 0c-9.9 0-18.5 3.6-25.7 10.8L163 32.3c-7.2 6.9-10.8 15.4-10.8 25.7 0 10.3 3.6 18.8 10.9 25.7l83.7 83.9H45.7c-9.9 0-17.9 3.6-24.1 10.7s-9.3 15.8-9.3 25.8v36.5c0 10.1 3.1 18.7 9.3 25.8s14.2 10.7 24.1 10.7h201L163 360.9c-7.2 7.2-10.8 15.9-10.8 26 0 10.1 3.6 18.8 10.9 26l21.4 21.4c7.4 7 16 10.6 25.7 10.6 9.9 0 18.6-3.5 26-10.6l185.9-185.9c7-7 10.6-15.7 10.6-26C432.5 211.9 429 203.4 422 196.7z"
                      fill={this.props.disabled ?
                          this.props.filled ?
                              '#e3e3e3'
                              :
                              '#b5b5b5'
                          :
                          this.props.filled ? '#fff' : this.props.color}
                /></svg>
        }
        if (this.props.icon === 'share') {
            icon = <svg style={stylesIcon} width={this.props.small ? '14px' : this.props.big ? '20px' : '16px'} viewBox="0 0 511.6 511.6">
                <path d="M506.2 179L360 32.8c-3.6-3.6-7.9-5.4-12.8-5.4s-9.2 1.8-12.8 5.4c-3.6 3.6-5.4 7.9-5.4 12.9v73.1h-64c-135.7 0-219 38.4-249.8 115.1C5 259.3 0 291 0 328.9c0 31.6 12.1 74.5 36.3 128.8 0.6 1.3 1.6 3.6 3 6.8 1.4 3.2 2.7 6.1 3.9 8.6 1.1 2.5 2.4 4.6 3.7 6.3 2.3 3.2 4.9 4.9 8 4.9 2.9 0 5.1-1 6.7-2.9 1.6-1.9 2.4-4.3 2.4-7.1 0-1.7-0.2-4.2-0.7-7.6 -0.5-3.3-0.7-5.6-0.7-6.7 -1-12.9-1.4-24.7-1.4-35.1 0-19.2 1.7-36.4 5-51.7 3.3-15.2 7.9-28.4 13.9-39.5 5.9-11.1 13.5-20.7 22.8-28.8 9.3-8.1 19.4-14.7 30.1-19.8 10.8-5.1 23.4-9.2 38-12.1 14.6-2.9 29.2-5 44-6.1s31.5-1.7 50.1-1.7h64v73.1c0 4.9 1.8 9.2 5.4 12.8 3.6 3.6 7.9 5.4 12.8 5.4 4.9 0 9.2-1.8 12.9-5.4l146.2-146.2c3.6-3.6 5.4-7.9 5.4-12.8C511.6 186.9 509.8 182.6 506.2 179z"
                      fill={this.props.disabled ?
                          this.props.filled ?
                              '#e3e3e3'
                              :
                              '#b5b5b5'
                          :
                          this.props.filled ? '#fff' : this.props.color}
                /></svg>
        }

        return (
            <button
                type={this.props.type}
                style={{ ...buttonDefaultStyles, ...this.props.style }}
                onClick={() => this.props.onClick()}
                onMouseEnter={() => this.hover()}
                onMouseLeave={() => this.leave()}
                disabled={this.props.disabled}>
                    {icon}
                    {this.props.children}
            </button>

        )
    }

};

Button.defaultProps  = {
    children: 'Click Me',
    onClick: function () {},
    filled: false,
    color: '#fff',
    border: '#b7b7b7',
    lighten: false,
    small: false,
    medium: false,
    big: false,
    disabled: false,
    type: 'button',
    icon:'',
    style: {},
};

Button.propTypes = {
    children: PropTypes.string.isRequired,
    onClick: PropTypes.func,
    filled: PropTypes.bool,
    lighten: PropTypes.bool,
    small: PropTypes.bool,
    medium: PropTypes.bool,
    big: PropTypes.bool,
    disabled: PropTypes.bool,
    color: PropTypes.string,
    border: PropTypes.string,
    style: PropTypes.object,
    type: PropTypes.string,
    icon: PropTypes.string,

};

module.exports = Button;
