import React from 'react';
import PropTypes from 'prop-types';
import {isTouch} from './utils';

class Check extends React.Component {
    constructor(props) {
        super(props);
        this.state = {hover: false};
    }

    shouldComponentUpdate(nextProps, nextState) {
        if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover) {
            return false;
        }
        return true;
    }

    hover() {
        this.setState({hover: true});
    }
    leave() {
        this.setState({hover: false});
    }

    render () {
        return (
            <svg viewBox="0 0 25 25"
                 style={{...{
                     cursor: 'pointer',
                     width: this.props.width,
                     boxSizing: 'border-box',
                     height: this.props.height
                 }, ...this.props.style
                 }}
                 onMouseEnter={() => this.props.disableHover ? null : this.hover()}
                 onMouseLeave={() =>  this.props.disableHover ? null : this.leave()}
                 onClick={() => this.props.onClick()}
            >
                <circle cx="12.5" cy="12.5" r="12.5" fill={this.state.hover ? this.props.backgroundHover : this.props.background}/>
                <path d="M19.4 9.3c0 0.2-0.1 0.4-0.2 0.6l-6.5 6.5 -1.2 1.2c-0.2 0.2-0.4 0.3-0.6 0.3 -0.2 0-0.4-0.1-0.6-0.2l-1.2-1.2 -3.2-3.2c-0.2-0.2-0.2-0.4-0.2-0.6 0-0.2 0.1-0.4 0.3-0.6l1.2-1.2c0.2-0.2 0.4-0.2 0.6-0.2 0.2 0 0.4 0.1 0.6 0.3l2.6 2.6 5.9-5.9c0.2-0.2 0.4-0.2 0.6-0.2s0.4 0.1 0.6 0.3l1.2 1.2C19.3 8.8 19.4 9 19.4 9.3z"
                      fill={this.state.hover ? this.props.colorHover : this.props.color}/>
            </svg>
        )
    }

};

Check.defaultProps  = {
    onClick: function () {},
    color: '#fff',
    style: {},
    colorHover: '#fff',
    background: '#10AA00',
    backgroundHover: '#10AA00',
    width: '100%',
    height: '100%',
    disableHover: isTouch(),
};

Check.propTypes = {
    onClick: PropTypes.func,
    color: PropTypes.string,
    colorHover: PropTypes.string,
    background: PropTypes.string,
    backgroundHover: PropTypes.string,
    width: PropTypes.string,
    height: PropTypes.string,
    style: PropTypes.object,
    disableHover: PropTypes.bool,
};

module.exports = Check;
