import React from 'react';
import PropTypes from 'prop-types';
import {isTouch} from './utils';

class Close extends React.Component {
    constructor(props) {
        super(props);
        this.state = {hover: false};
    }

    shouldComponentUpdate(nextProps, nextState) {
        if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover) {
            return false;
        }
        return true;
    }

    hover() {
        this.setState({hover: true});
    }
    leave() {
        this.setState({hover: false});
    }

    render () {
        const viewBox = this.props.thin === true ? "0 0 122.5 122.5" :"0 0 48 48";
        const d = this.props.thin === true ? "M85.8 81c-6.6-6.6-13.1-13.1-19.7-19.7 12-12 24-24 36-36 6.5-6.5 13-13 19.5-19.5 3.1-3.1-1.7-7.9-4.8-4.8 -11.9 11.9-23.8 23.8-35.7 35.7C74.4 43.3 67.8 49.9 61.3 56.5c-12-12-24-24-36-36C18.8 14 12.3 7.5 5.8 1 2.7-2.1-2.1 2.7 1 5.8 12.9 17.8 24.9 29.7 36.8 41.6c6.6 6.6 13.1 13.1 19.7 19.7C44.5 73.3 32.5 85.3 20.5 97.2 14 103.7 7.5 110.2 1 116.7c-3.1 3.1 1.7 7.9 4.8 4.8 11.9-11.9 23.8-23.8 35.7-35.7 6.6-6.6 13.1-13.1 19.7-19.7 12 12 24 24 36 36 6.5 6.5 13 13 19.5 19.5 3.1 3.1 7.9-1.7 4.8-4.8C109.6 104.8 97.7 92.9 85.8 81z" :"M28.2 24L47.1 5.1c1.2-1.2 1.2-3.1 0-4.2 -1.2-1.2-3.1-1.2-4.2 0L24 19.7 5.1 0.9c-1.2-1.2-3.1-1.2-4.2 0 -1.2 1.2-1.2 3.1 0 4.2l18.9 18.9L0.9 42.9c-1.2 1.2-1.2 3.1 0 4.2C1.5 47.7 2.2 48 3 48s1.5-0.3 2.1-0.9l18.9-18.9L42.9 47.1c0.6 0.6 1.4 0.9 2.1 0.9s1.5-0.3 2.1-0.9c1.2-1.2 1.2-3.1 0-4.2L28.2 24z";
        return (
            <svg viewBox={viewBox}
                 style={{...{
                     cursor: 'pointer',
                     backgroundColor: this.state.hover ? this.props.backgroundHover : this.props.background,
                     width: this.props.width,
                     boxSizing: 'border-box',
                     height: this.props.height
                 }, ...this.props.style
                 }}
                 onMouseEnter={() => this.props.disableHover ? null : this.hover()}
                 onMouseLeave={() =>  this.props.disableHover ? null : this.leave()}
                 onClick={() => this.props.onClick()}
            >
                <path d={d}
                      fill={this.state.hover ? this.props.colorHover : this.props.color}
                />
            </svg>
        )
    }

};

Close.defaultProps  = {
    onClick: function () {},
    color: 'black',
    style: {},
    colorHover: 'red',
    background: 'transparent',
    backgroundHover: 'transparent',
    width: '100%',
    height: '100%',
    disableHover: isTouch(),
    thin: false
};

Close.propTypes = {
    onClick: PropTypes.func,
    color: PropTypes.string,
    colorHover: PropTypes.string,
    background: PropTypes.string,
    backgroundHover: PropTypes.string,
    width: PropTypes.string,
    height: PropTypes.string,
    style: PropTypes.object,
    disableHover: PropTypes.bool,
    thin: PropTypes.bool,
};

module.exports = Close;
