import React from 'react';
import PropTypes from 'prop-types';
import {isTouch} from './utils';

class Filter extends React.Component {
    constructor(props) {
        super(props);
        this.state = {hover: false};
    }

    shouldComponentUpdate(nextProps, nextState) {
        if (this.props.color === this.props.colorHover && this.props.background === this.props.backgroundHover && this.props.color === nextProps.color && this.state.hover === nextState.hover) {
            return false;
        }
        return true;
    }

    hover() {
        this.setState({hover: true});
    }
    leave() {
        this.setState({hover: false});
    }

    render () {
        return (
            <svg viewBox="0 0 402.6 402.6"
                 style={{...{
                     cursor: 'pointer',
                     backgroundColor: this.state.hover ? this.props.backgroundHover : this.props.background,
                     width: this.props.width,
                     boxSizing: 'border-box',
                     height: this.props.height
                 }, ...this.props.style
                 }}
                 onMouseEnter={() => this.props.disableHover ? null : this.hover()}
                 onMouseLeave={() =>  this.props.disableHover ? null : this.leave()}
                 onClick={() => this.props.onClick()}
            >
                <path d="M400.9 11.4c-3.2-7.4-8.8-11.1-16.9-11.1H18.6c-8 0-13.6 3.7-16.8 11.1 -3.2 7.8-1.9 14.5 4 20l140.8 140.8v138.8c0 5 1.8 9.2 5.4 12.9l73.1 73.1c3.4 3.6 7.7 5.4 12.9 5.4 2.3 0 4.7-0.5 7.1-1.4 7.4-3.2 11.1-8.9 11.1-16.8V172.2L396.9 31.4C402.8 25.9 404.1 19.2 400.9 11.4z"
                      fill={this.state.hover ? this.props.colorHover : this.props.color}/>
            </svg>
        )
    }

};

Filter.defaultProps  = {
    onClick: function () {},
    color: 'black',
    style: {},
    colorHover: 'red',
    background: 'transparent',
    backgroundHover: 'transparent',
    width: '100%',
    height: '100%',
    disableHover: isTouch(),
};

Filter.propTypes = {
    onClick: PropTypes.func,
    color: PropTypes.string,
    colorHover: PropTypes.string,
    background: PropTypes.string,
    backgroundHover: PropTypes.string,
    width: PropTypes.string,
    height: PropTypes.string,
    style: PropTypes.object,
    disableHover: PropTypes.bool,
};

module.exports = Filter;
