import React from 'react';
import PropTypes from 'prop-types';

class Warning extends React.Component {


    render () {

        const styles = {...{
            width: this.props.width,
            boxSizing: 'border-box',
            height: this.props.height
        }, ...this.props.style
        }

        return (
            <svg viewBox="0 0 488.5 488.5"
                 style={styles}
            >
                <path d="M484.1 412l-212.2-367.6c-12.3-21.3-43.1-21.3-55.4 0l-212.2 367.6c-12.3 21.3 3.1 48 27.7 48h424.4C481 460 496.4 433.3 484.1 412zM244.5 157.6c13.6 0 24.6 11.3 24.2 24.9l-4 139.6c-0.3 11-9.3 19.7-20.3 19.7s-20-8.8-20.3-19.7l-3.9-139.6C219.9 168.9 230.8 157.6 244.5 157.6zM244.2 410.1c-13.9 0-25.2-11.3-25.2-25.2 0-13.9 11.3-25.2 25.2-25.2s25.2 11.3 25.2 25.2S258.1 410.1 244.2 410.1z"
                      fill={this.props.color}/>
            </svg>
        )
    }

};

Warning.defaultProps  = {
    color: 'black',
    style: {},
    width: '100%',
    height: '100%',

};

Warning.propTypes = {
    color: PropTypes.string,
    width: PropTypes.string,
    height: PropTypes.string,
    style: PropTypes.object,
};

module.exports = Warning;
