import React from 'react';
import styles from './filter.css';
import {Input, Close, Search, Filter} from '../../../index';

const filter = ({
    color,
    changeActivePosition,
    activePosition,
    changeActiveClub,
    activeClub,
    changeActiveStats,
    activeStats,
    activeSearchTab,
    toogleActiveFilter,
    textSearchVal,
    changeTextSearchVal
}) => {

    var content = null;
    if (!activeSearchTab) {
        content = <div className={styles.filterContent}>
            <Input
                type="select"
                borderActive={color}
                border="#acacac"
                options={[{id: 0, name: 'Choose position'}, {id: 1, name: 'GK'}, {id: 2, name: 'DF'}, {id: 3, name: 'FW'}, {id: 4, name: 'MF'}]}
                onChange={changeActivePosition}
                value={activePosition}
            />
            <Input
                style={{marginLeft: '25px'}}
                type="select"
                borderActive={color}
                border="#acacac"
                options={[{id: 0, name: 'Choose club'}, {id: 1, name: 'Arsenal'}, {id: 2, name: 'West Ham'}]}
                onChange={changeActiveClub}
                value={activeClub}
            />
            <div className={styles.filterWithText}>
                <div className={styles.textBeforeselect}>Show</div>
                <Input
                    type="select"
                    borderActive={color}
                    border="#acacac"
                    options={[{id: 'goals', name: 'Goals'}, {id: 'assists', name: 'Assists'}, {id: 'pop', name: 'Popularity'}]}
                    onChange={changeActiveStats}
                    value={activeStats}
                />
            </div>
        </div>;
    } else if (activeSearchTab) {
        content =
            <div className={styles.filterContent}>
                <div className={styles.textSearchBlock}>
                    <Search style={{position: 'absolute', top: '0px', left: '15px'}} color="#999" colorHover="#999" width="20px"/>
                    <Input
                        width="100%"
                        style={{paddingLeft: '45px'}}
                        type="text"
                        borderActive={color}
                        border="#acacac"
                        onChange={changeTextSearchVal}
                        value={textSearchVal}

                    />
                    <div className={styles.clear}>
                        <Close
                            style={{padding: '5px', borderRadius: '30px'}}
                            width="30px"
                            background="#999"
                            color="#fff"
                            colorHover={color}
                            onClick={() => changeTextSearchVal('')}
                        />
                    </div>
                </div>
            </div>;
    }
    return (
        <div className={styles.filterBlock}>
            <div className={styles.choose}>
                <div className={styles.filter}>
                    <Filter onClick={() => toogleActiveFilter(false)}  style={{padding: '13px'}} color={!activeSearchTab ? color : '#999'} colorHover={color} background={!activeSearchTab ? '#f7f7f7' : '#fff'} backgroundHover="#f7f7f7"/>
                </div>
                <div className={styles.search}>
                    <Search onClick={() => toogleActiveFilter(true)} style={{padding: '13px'}} color={activeSearchTab ? color : '#999'} colorHover={color} background={activeSearchTab ? '#f7f7f7' : '#fff'} backgroundHover="#f7f7f7"/>
                </div>
            </div>
            {content}
        </div>
    )
}

module.exports = filter