import React from 'react';
import Close from './Close';
import PropTypes from 'prop-types';


const holder={  width:'100%',
    height:'100%',
    position:'fixed',
    top:'0',
    left:'0',
    transform: 'translateZ(0)',
    transform: 'translate3d(0, 0, 0)',
    zIndex: '999'
}
const overlay={
    width:'100%',
    height:'100%',
    position:'relative',
    overflowY:'auto',
    zIndex:'1',
    background: 'rgba(0,0,0,0.5)'
}

const close={
    position: 'absolute',
    top: '15px',
    right: '15px'
}

const shadow={
    width:'100%',
    height:'100%',
    position:'absolute',
    top:'0',
    left:'0',
    zIndex:'0'
}
class Modal extends React.Component {
    render () {
        const content={
            zIndex:'1',
            backgroundColor:'#fcfcfc',
            position:'relative',
            boxShadow:this.props.shadow === true ? '0 0 20px #333': 'none' ,
            margin:'auto',
            overflow:'hidden',
            //right: '0',
            top: '50%',
            left: '50%',
            transform: 'translate(-50%, -50%)',
            position: 'fixed',
            minHeight: '300px',
            borderRadius: this.props.roundCorners === true ? '5px': '0px',
            width: '100%',
            maxWidth: this.props.maxWidth
        }
        const contentStyle={ ...content, ...this.props.contentStyle }
        return (
                <div >
                    <div style={holder}>
                        <div style={overlay} onClick={() => this.props.remove()} ></div>
                        <div style={contentStyle}>
                            {this.props.close ?
                                <div style={close}><Close thin={this.props.closeThin} width={this.props.closeWidth} height={this.props.closeWidth} disableHover onClick={() => this.props.remove()} color={this.props.closeColor}/></div>
                                :
                                null
                            }
                            {this.props.children}
                        </div>
                    </div>
                    <div style={shadow}></div>
                </div>
        )
    }
}


Modal.defaultProps  = {
    children: {},
    remove: function () {},
    close: true,
    closeColor: '#a5a5a5',
    closeWidth: '20px',
    maxWidth: '500px',
    closeThin: false,
    roundCorners: false,
    shadow: false,
    contentStyle: {},

};

Modal.propTypes = {
    children: PropTypes.object.isRequired,
    remove: PropTypes.func,
    close: PropTypes.bool,
    closeThin: PropTypes.bool,
    shadow: PropTypes.bool,
    borderRadius: PropTypes.bool,
    roundCorners: PropTypes.bool,
    closeColor: PropTypes.string,
    closeWidth: PropTypes.string,
    maxWidth: PropTypes.string,
    contentStyle: PropTypes.object,
};

module.exports = Modal;