var path = require('path');
var webpack = require('webpack');

var CleanWebpackPlugin = require('clean-webpack-plugin');

module.exports = {
    devtool: 'eval',
    entry: [
        path.join(__dirname, 'src/')
    ],
    output: {
        publicPath:  '/lib1/',
        path:  path.join(__dirname, 'lib1/'),
        filename: '[name].js',

        //chunkFilename: "[name]-[hash].bundle.js"
    },

    plugins: [
      //  new webpack.optimize.CommonsChunkPlugin({name: 'cammons'}),
   /*     new webpack.DefinePlugin({
            'process.env.NODE_ENV': JSON.stringify('production'),
        }),
        new webpack.optimize.UglifyJsPlugin({
            compressor: {
                screw_ie8: true,
                warnings: false,
            },
        }),*/
        new CleanWebpackPlugin(['./lib1'], {
        }),

    ],
    module: {
        rules: [
       /*     {
                test: /\.js$/,
                enforce: "pre",
                loader: 'eslint-loader',
            },*/
            {
                test: /\.js$/,
                loader: 'babel-loader',
                include: path.resolve(__dirname, 'src/')
            },
            {
                test: /\.css$/,
                use: [
                    {
                        loader: 'style-loader',
                    },
                    {
                        loader: 'css-loader',
                        options: {
                            // CSS Loader https://github.com/webpack/css-loader
                            importLoaders: 1,
                            // CSS Modules https://github.com/css-modules/css-modules
                            modules: true,
                            localIdentName:'[hash:base64:5]',
                            // CSS Nano http://cssnano.co/options/
                            minimize: true,
                            discardComments: { removeAll: true },
                        },
                    },
                    {
                        loader: 'postcss-loader',
                        options: {
                            config: {
                                path: './postcss.config.js'
                            }
                        },
                    },
                ]
            },
            {
                test: /.*\.(gif|png|jpe?g|svg)$/i,
                loader: 'url-loader',
                options: {
                    limit: 100000
                }
            }
        ]
    }
};
